// Generated by CoffeeScript 1.8.0
(function() {
  var Logs, Util, defaults, sticker_defaults, util, _, _colors;

  Util = require('./util');

  util = new Util();

  _colors = require('colors');

  _ = require('underscore');

  defaults = {
    'identifier': null,
    'showDateTime': true,
    'filePath': false,
    'showIcons': true,
    'trace': null,
    'dateTimeFormat': 'UTC:h:MM:ss TT Z'
  };

  sticker_defaults = {
    'color': 'yellow',
    'align': 'center'
  };

  Logs = (function() {
    function Logs(options) {
      var methods, self;
      this.options = options;
      methods = {
        'log': {
          'success': function(message, options) {
            return self.outputLog('success', message, options);
          },
          'warn': function(message, options) {
            return self.outputLog('warn', message, options);
          },
          'error': function(message, options) {
            return self.outputLog('error', message, options);
          },
          'info': function(message, options) {
            return self.outputLog('info', message, options);
          }
        },
        'action': {
          'success': function(action_name, message) {
            return util.printAction('success', action_name, message);
          },
          'error': function(action_name, message) {
            return util.printAction('error', action_name, message);
          },
          'warn': function(action_name, message) {
            return util.printAction('warn', action_name, message);
          },
          'info': function(action_name, message) {
            return util.printAction('info', action_name, message);
          }
        },
        'progress': {
          'start': function(message) {
            return util.startProgress('started at', message);
          },
          'stop': function() {
            return util.stopProgress();
          }
        },
        'icon': function(type) {
          return util.makeIcons(type);
        },
        'highlight': {
          'start': function(message) {
            return util.startHighlight(message);
          },
          'end': function(message) {
            return util.endHighlight();
          }
        },
        'print': {
          'ol': function(steps) {
            return util.printList('ol', steps, 0);
          },
          'li': function(steps) {
            return util.printList('li', steps, 0);
          }
        },
        'sticker': {
          'note': function(message, rawMessage) {
            return util.stickerMessage(message, rawMessage);
          },
          'show': function(options) {
            var align, color;
            options = _.extend(sticker_defaults, options);
            align = options.align;
            color = options.color;
            return util.showSticker(align, color);
          }
        }
      };
      this.options = _.extend(defaults, options);
      self = this;
      _.each(methods, function(v, k) {
        return self[k] = v;
      });
    }

    Logs.prototype.colors = util.colorsClone;

    Logs.prototype.outputLog = function(type, message, options) {
      var dateTimeFormat, filePath, icons, identifier, showDateTime, trace;
      if (!options || !options.trace) {
        this.options.trace = null;
      }
      options = _.extend(this.options, options);
      identifier = options.identifier || null;
      showDateTime = options.showDateTime || null;
      trace = options.trace || null;
      filePath = options.filePath || null;
      icons = options.showIcons || null;
      dateTimeFormat = options.dateTimeFormat;
      return util.logBuilder(type, message, identifier, showDateTime, trace, filePath, icons, dateTimeFormat);
    };

    return Logs;

  })();

  module.exports = Logs;

}).call(this);
